package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.busi.collect;

import cn.estsh.i3plus.ext.mes.pcn.pojo.util.MesPcnExtConstWords;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import org.springframework.util.StringUtils;

import java.util.Map;
import java.util.StringJoiner;

/**
 * 第三方PLC数据采集-监控处理器-工位节拍
 */
public class SxThirdPartyPlcCollectCellTaktMonitorHandler extends SxThirdPartyPlcCollectMonitorHandler {

    private volatile String plcCode2Flag;

    private volatile String plcCode2Data;

    public SxThirdPartyPlcCollectCellTaktMonitorHandler(String org, String key) {
        super(org, key);
        initStepResult();
    }

    private void initStepResult() {
        ((Map<String, Object>) stepResult.getData()).put(MesPcnExtConstWords.BUSI_CODE, MesPcnExtConstWords.COLLECT_CELL_TAKT);
        ((Map<String, Object>) stepResult.getData()).put(MesPcnExtConstWords.WORK_CENTER_CODE, key.split(MesPcnExtConstWords.COLON)[2]);
        ((Map<String, Object>) stepResult.getData()).put(MesPcnExtConstWords.WORK_CELL_CODE, key.split(MesPcnExtConstWords.COLON)[3]);
    }

    @Override
    public SxThirdPartyPlcCollectCellTaktMonitorHandler doRetry(Object obj) {
        super.doRetry(obj);
        if (isRetry) return this;
        String[] plcCodeArr = obj.toString().split(MesPcnExtConstWords.COMMA);
        if (StringUtils.isEmpty(plcCode2Flag) || !plcCode2Flag.equals(plcCodeArr[0])) plcCode2Flag = null;
        if (StringUtils.isEmpty(plcCode2Data) || !plcCode2Data.equals(plcCodeArr[1])) plcCode2Data = null;
        if (!StringUtils.isEmpty(plcCode2Flag) && !StringUtils.isEmpty(plcCode2Data)) return this;
        isRetry = true;
        this.plcCode2Flag = plcCodeArr[0];
        this.plcCode2Data = plcCodeArr[1];
        return this;
    }

    @Override
    public void execMonitor() {

        while (isOpen) {

            if (StringUtils.isEmpty(plcCode2Flag) || StringUtils.isEmpty(plcCode2Data)) continue;

            if (isRetry || null == filterChain) instanceFilterChain();

            filterChain.exec(stepResult);

        }
    }

    private void instanceFilterChain() {
        filterChain = new SxThirdPartyPlcCollectStepFilterChain(org, key, MesPcnExtConstWords.COLLECT_CELL_TAKT)
                .clearField(plcCode2Flag, plcCode2Data).sleepTime2UnComplete(1000L).sleepTime2Completed(2000L)
                .add(new SxThirdPartyPlcCollectReadPlcStepService(plcCode2Flag).targetValue(new StringJoiner(MesPcnExtConstWords.COMMA).add(CommonEnumUtil.TRUE_OR_FALSE.TRUE.name().toLowerCase()).add(CommonEnumUtil.TRUE_OR_FALSE.TRUE.getValueStr()).toString()))
                .add(new SxThirdPartyPlcCollectReadPlcStepService(plcCode2Data))
                .add(new SxThirdPartyPlcCollectWritePlcStepService(plcCode2Flag).targetValue(MesPcnExtConstWords.ZERO_STR))
                .add(new SxThirdPartyPlcCollectCellTaktStepService().targetField(plcCode2Data));
        isRetry = false;
    }

}
